abund=mrdfits('$ATOMDB/APED/misc/Abundances.fits',1,data_h)

read_linelist,'apec_aroth_line_2.fits',aroth_line,pt1,pn1,pl1
read_coco,'apec_aroth_coco_2.fits',aroth_coco,pt3,pn3,pl3

; from apec.par find the list of elements used in the calculation:
; IncAtoms,s,a,"H,He,C,N,O,Ne,Mg,Al,Si,S,Ar,Ca,Fe,Ni",,,"Include all ions of listed atoms"
; Note H is always 12
element_array=[2,   6,  7,  8,  10,  12,  13,  14, 16,  18,  20,  26,  28]

ratio=[10.^(abund(3).He-abund(1).He),$
	10.^(abund(3).C-abund(1).C),$
	10.^(abund(3).N-abund(1).N),$
	10.^(abund(3).O-abund(1).O),$
	10.^(abund(3).Ne_-abund(1).Ne_),$
	10.^(abund(3).Mg-abund(1).Mg),$
	10.^(abund(3).Al-abund(1).Al),$
	10.^(abund(3).Si-abund(1).Si),$
	10.^(abund(3).S -abund(1).S),$
	10.^(abund(3).Ar-abund(1).Ar),$
	10.^(abund(3).Ca-abund(1).Ca),$
	10.^(abund(3).Fe-abund(1).Fe),$
	10.^(abund(3).Ni-abund(1).Ni)]

aroth_line_feldman=aroth_line
aroth_coco_feldman=aroth_coco

for i=0,n_elements(element_array)-1 do begin
    indx=where(aroth_line.element eq element_array(i))
    aroth_line_feldman(indx).epsilon = ratio(i) * aroth_line(indx).epsilon
    indx=where(aroth_coco.Z eq element_array(i))
    aroth_coco_feldman(indx).continuum = ratio(i) * aroth_coco(indx).continuum
    aroth_coco_feldman(indx).pseudo = ratio(i) * aroth_coco(indx).pseudo
endfor

; example spectrum

tt=1.0e+07

nbin=100
Ebin = make_range(1.,20.,nbin) 

aroth=calc_spectrum(aroth_line,aroth_coco,Ebin,tt,/ANGSTROM)
aroth_feldman=calc_spectrum(aroth_line_feldman,aroth_coco_feldman,Ebin,tt,/ANGSTROM)

plot_io,ebin,aroth_feldman
oplot,ebin,aroth,line=4

end
