FUNCTION extract_strong, data, Z, rmJ, MIN_EPSILON=min_epsilon,SILENT=silent
;
;  Extract the strongest lines for each ion, at whatever temperature.
;
if ((Z ne 0)and(rmJ ne 0)) then begin
    gp = where(data.element eq Z and data.ion eq rmJ,count)
    if (count eq 0) then begin
        if (n_elements(silent) ne 0) then print,'No Z,rmJ =',Z,rmJ,$
          ' found in data.'
        return,-1
    endif
    lines = data(gp)
endif
if ((Z ne 0)and(rmJ eq 0)) then begin
    gp = where(data.element eq Z,count)
    if (count eq 0) then begin
        if (n_elements(silent) ne 0) then print,'No Z =',Z,' found in data.'
        return,-1
    endif
    lines = data(gp)
endif
if ((Z eq 0)and(rmJ ne 0)) then begin
    if (n_elements(silent) ne 0) then print,'Why set only the ion state?'
    return,-1
endif
if ((Z eq 0)and(rmJ eq 0)) then lines = data
;
;  lines is now set to be the correct structure
;
Nlines = n_elements(lines)
;
;  Now set min_epsilon, if not already set
;
if (n_elements(min_epsilon) eq 0) then min_epsilon = 0.0
;
;  And begin searching for strong lines
;
sz = strcompress(string(lines.element),/remove)
sj = strcompress(string(lines.ion),/remove)
sll= strcompress(string(lines.ll),/remove)
sul= strcompress(string(lines.ul),/remove)
ion_list = sz+sj+'_'+sul+'t'+sll
sort_ion_list = ion_list(sort(ion_list))
uniq_ion = sort_ion_list(uniq(sort_ion_list))

for i=0,n_elements(uniq_ion)-1 do begin
    match = strcmp(ion_list,uniq_ion(i))
    gp = where(match eq 1,count)
    if (count eq 0) then begin
        print,'What, no matches now?'
        stop
    endif
    max_pt = where(lines(gp).epsilon eq max(lines(gp).epsilon),count)
    if (lines(gp(max_pt(0))).epsilon ge min_epsilon) then begin
        if (n_elements(strong) eq 0) then begin
            strong = lines(gp(max_pt(0)))
        endif else begin
            strong = [strong,lines(gp(max_pt(0)))]
        endelse
    endif
endfor

if (n_elements(strong) eq 0) then begin
    if (min_epsilon eq 0.0) then begin
        print,'Very strange error.'
        stop
    endif else begin
        if (n_elements(silent) ne 0) then print,'No strong lines found.'
        return,-1
    endelse
endif

return, strong
end
