FUNCTION match_header, filename, Z, rmJ, datatype, N_ext=N_ext
;
;  Reads FITS file filename, and looks for an extension
;  with data for element Z, ion rmJ, and datatype type.
;  Returns the number of the extension if found; if not,
;  returns -1.
;
;
if (n_elements(n_ext) eq 0) then begin
    defsysv,'!TEXTOUT',1
    defsysv,'!TEXTUNIT',0
    fits_info,filename,/silent, n_ext=n_ext
endif

result = -1
done = 0
iExt = 1
if (iExt gt N_ext) then done = 1
while (not(done)) do begin
    unit = fxposit(filename, iExt, /readonly) ; Position file pointer
    fxhread, unit, header                     ; Get header
    fileZ    = fxpar(header, 'ELEMENT')
    fileIonJ = fxpar(header, 'ION_STAT')
    filetype = fxpar(header, 'HDUCLAS1')
    if ((fileZ eq Z)and(fileIonJ eq rmJ-1)and $
        ((strcompress(filetype,/remove_all) eq datatype))) then begin
        done = 1
        result = iExt
    endif 

    free_lun,unit
    iExt = iExt+1
    if (iExt gt N_ext) then done=1
endwhile

return, result
end
