PRO read_coco, filename, coco, T_vec, N_vec, lambda_vec

;
;  Reads the continuum data from a fits file
;
done = 0
ext = 2

while (not(done)) do begin
    data = mrdfits(filename,ext,header)
    if (n_tags(data) ne 0) then begin
        lambda_val = interp_header(header, 'TOT_COCO')
        T_val = interp_header(header,'TEMPERAT')
        N_val = interp_header(header,'DENSITY')
        Nrows = n_elements(data)
        if (ext eq 2) then begin
            T_vec = T_val
            N_vec = N_val
            lambda_vec = lambda_val
            coco = replicate({Coco_S},Nrows)
            for i=0,Nrows-1 do begin
                coco(i).Temperature = T_val
                coco(i).Density = N_val
                coco(i).Z = data(i).Z
                coco(i).rmJ = data(i).rmJ
                coco(i).N_Cont = data(i).N_Cont
                coco(i).E_Cont = data(i).E_Cont
                coco(i).Continuum = data(i).Continuum
                coco(i).Cont_Err = data(i).Cont_Err
                coco(i).N_Pseudo = data(i).N_Pseudo
                coco(i).E_Pseudo = data(i).E_Pseudo
                coco(i).Pseudo = data(i).Pseudo
                coco(i).Pseudo_Err = data(i).Pseudo_Err
            endfor
        endif else begin
            T_vec = [T_vec,T_val]
            N_vec = [N_vec,N_val]
            lambda_vec = [lambda_vec,lambda_val]
            coco_tmp = replicate({Coco_S},Nrows)
            for i=0,Nrows-1 do begin
                coco_tmp(i).Temperature = T_val
                coco_tmp(i).Density = N_val
                coco_tmp(i).Z = data(i).Z
                coco_tmp(i).rmJ = data(i).rmJ
                coco_tmp(i).N_Cont = data(i).N_Cont
                coco_tmp(i).E_Cont = data(i).E_Cont
                coco_tmp(i).Continuum = data(i).Continuum
                coco_tmp(i).Cont_Err = data(i).Cont_Err
                coco_tmp(i).N_Pseudo = data(i).N_Pseudo
                coco_tmp(i).E_Pseudo = data(i).E_Pseudo
                coco_tmp(i).Pseudo = data(i).Pseudo
                coco_tmp(i).Pseudo_Err = data(i).Pseudo_Err
            endfor
            coco = [[coco],[coco_tmp]]
        endelse
        ext = ext + 1
    endif else begin
        done = 1
    endelse
endwhile

return
end
