PRO read_linelist, filename, linelist, T_vec, N_vec, lambda_vec, SPEX=spex
;
;  Reads the linelist from a fits file.
;
if (n_params() lt 2) then begin
    print,'Call as:'
    print,'read_linelist, filename, linelist, temperature, density, emission'
    print,'or:'
    print,'read_linelist, filename, linelist'
    print,'linelist is an array of structures; use help, /str, linelist'
    print,'to view the data'
    return
end

done = 0
ext = 1
ll_var = {line_S, lambda: 1., epsilon:1., element:1, ion:1, temperature:1.,$
          density:1., ul:1, ll:1}
sl_var = {SPEXline_S, lambda: 1.0, epsilon:1.0, element:1, ion:1, $
          temperature:1.0, density:1.0, ul:1, ll:1, lineid:1,$
          spextype:'0123456789'}

header = headfits(filename,exten=ext)
first = 1
while (n_elements(header) ne 1) do begin
    Nlines = interp_header(header,'N_LINES',/INT_RESULT,/SILENT)
    Nlines = Nlines(0)
    if (Nlines gt 0L) then begin    
        data = mrdfits(filename,ext,header)
        if (n_tags(data) ne 0) then begin
            lambda_val = interp_header(header, 'TOT_LINE',/SILENT)
            T_val = interp_header(header,'TEMPERAT')
            N_val = interp_header(header,'DENSITY')
            if (first eq 1) then begin
                first = 0
                T_vec = T_val
                N_vec = N_val
                lambda_vec = lambda_val
                if (n_elements(spex) eq 0) then begin
                    linelist = replicate({line_S},Nlines(0))
                endif else begin
                    linelist = replicate({SPEXline_S},Nlines(0))
                endelse
                linelist.lambda = data.lambda
                linelist.epsilon= data.epsilon
                linelist.element= data.element
                linelist.ion = data.ion
                linelist.ul = data.upperlev
                linelist.ll = data.lowerlev
                if (n_elements(spex) ne 0) then begin
                    linelist.lineid = data.lineid
                    linelist.spextype = data.spextype
                endif
                linelist.temperature = T_val(0)*(1.+fltarr(Nlines(0)))
                linelist.density = N_val(0)*(1.+fltarr(Nlines(0)))
            endif else begin
                T_vec = [T_vec,T_val]
                N_vec = [N_vec,N_val]
                lambda_vec = [lambda_vec,lambda_val]
                if (n_elements(spex) eq 0) then begin
                    line_tmp = replicate({line_S},Nlines(0))
                endif else begin
                    line_tmp = replicate({SPEXline_S},Nlines(0))
                endelse
                line_tmp.lambda = data.lambda
                line_tmp.epsilon= data.epsilon
                line_tmp.element= data.element
                line_tmp.ion = data.ion
                line_tmp.ul = data.upperlev
                line_tmp.ll = data.lowerlev
                if (n_elements(spex) ne 0) then begin
                    line_tmp.lineid = data.lineid
                    line_tmp.spextype = data.spextype
                endif
                line_tmp.temperature = T_val(0)*(1.+fltarr(Nlines(0)))
                line_tmp.density = N_val(0)*(1.+fltarr(Nlines(0)))
                linelist = [linelist,line_tmp]
            endelse
        endif
    endif
    ext = ext+1
    header = headfits(filename,exten=ext)
endwhile

return
end
