FUNCTION roman_element, Z, rmJ

; Returns the astronomical ion name for the Z, rmJ ion. 
  
Element=['H','He','Li','Be','B','C','N','O','F','Ne',$
         'Na','Mg','Al','Si','P','S','Cl','Ar','K','Ca',$
         'Sc','Ti','V','Cr','Mn','Fe','Co','Ni','Cu','Zn']
Numeral=['I','II','III','IV','V','VI','VII','VIII','IX','X',$
         'XI','XII','XIII','XIV','XV','XVI','XVII','XVIII',$
         'XIX','XX','XXI','XXII','XXIII','XXIV','XXV','XXVI',$
         'XXVII','XXVIII','XXIX','XXX']

if ((Z lt 1)or(Z gt 30)) then begin
    result = 'Bad Z'
endif else begin
    if ((rmJ lt 1)or(rmJ gt Z+1)) then begin
        result = 'Bad J'
    endif else begin
        result = strcompress(Element[Z-1]+' '+Numeral[rmJ-1])
    endelse
endelse
    
return, result
end

FUNCTION element_name, Z

; Returns the astronomical ion name for the atom with Z protons
  
Element=['H','He','Li','Be','B','C','N','O','F','Ne',$
         'Na','Mg','Al','Si','P','S','Cl','Ar','K','Ca',$
         'Sc','Ti','V','Cr','Mn','Fe','Co','Ni','Cu','Zn']

if ((Z lt 1)or(Z gt 30)) then begin
    result = 'Bad Z'
endif else begin
    result = strcompress(Element[Z-1])
endelse

return, result
end

FUNCTION roman_name, J

; Returns the roman number for J
  
Numeral=['I','II','III','IV','V','VI','VII','VIII','IX','X',$
         'XI','XII','XIII','XIV','XV','XVI','XVII','XVIII',$
         'XIX','XX','XXI','XXII','XXIII','XXIV','XXV','XXVI',$
         'XXVII','XXVIII','XXIX','XXX']

if ((J lt 1)or(J gt 30)) then begin
    result = 'Bad J'
endif else begin
    result = strcompress(Numeral[J-1])
endelse

return, result
end


FUNCTION element_number, atom

;  /* Returns the Z value for a given atom name.  */
  
Element = ['H','He','Li','Be','B','C','N','O','F','Ne',$
           'Na','Mg','Al','Si','P','S','Cl','Ar','K','Ca',$
           'Sc','Ti','V','Cr','Mn','Fe','Co','Ni','Cu','Zn']
  
Z = -1

for iZ=0,29 do begin
    if (atom eq Element[iZ]) then Z = iZ + 1;
endfor

return, Z                      
end


FUNCTION roman_number, roman

;  /* Returns the arabic value for a roman number */
  
Numeral = ['I','II','III','IV','V','VI','VII','VIII','IX','X',$
           'XI','XII','XIII','XIV','XV','XVI','XVII','XVIII',$
           'XIX','XX','XXI','XXII','XXIII','XXIV','XXV','XXVI',$
           'XXVII','XXVIII','XXIX','XXX']

J = -1              
for iJ=0,29 do begin
 if (roman eq  Numeral[iJ]) then J = iJ + 1;
endfor

return, J
end
