FUNCTION select_line, data, element, ion, wavelength, SILENT=silent

if (n_params() lt 4) then begin
    print,'Call as'
    print,'result = select_line(data, element, ion, wavelength,/SILENT)'
    print,'The result will be data with the given ionic state and the'
    print,'closest wavelength to the given one.  Set /SILENT if you do'
    print,'not want any error messages.'
    return,' '
endif

gp = where(data.element eq element and data.ion eq ion,count)
if (count eq 0) then begin
    if (n_elements(silent) ne 0) then $
      print,'No data in structure for ',roman_element(element,ion)
    result = -1
endif

s = data(gp)

mindiff = min(abs(s.lambda - wavelength))
gp = where(abs(s.lambda - wavelength) eq mindiff,count)
if (count eq 0) then begin
    print,'weird'
    stop
endif

result = s(gp)

return, result
end
